package feec.ia725.cg.core;

import java.util.Collection;
import java.util.Iterator;
import java.util.Map;

import javax.media.opengl.GL;

public class CompositeModel extends AbstractModel {
 
	private Map models;
    
	/**
     * 
     * @param code
     * @return
	 */ 
	public SimpleModel getModel(String code) {
        return (SimpleModel) models.get(code);
	}
    
    /**
     * 
     * @param code
     * @param model
     */
    public void putModel(String code, SimpleModel model) {
        models.put(code, model);
    }

    /**
     * @see feec.ia725.cg.core.Model#render(javax.media.opengl.GL)
     */
    public void render(GL gl) {
        Collection modelList = models.values();
        
        for (Iterator iter = modelList.iterator(); iter.hasNext();) {
            Model model = (Model) iter.next();
            model.render(gl);
        }
    }

}
 
