/*
 * Coordinate4d.java
 * Created in 05/04/2006
 */
package feec.ia725.cg.core;

/**
 * @author Lucas Shindi Shimo (lshimo@gmail.com)
 *
 */
public class Coordinate4d extends Vertex {
    /** Serial Version UID. */
    private static final long serialVersionUID = 1L;

    /** W position */
    private double w;

    /////////////////////////
    //    CONSTRUCTORS     //
    /////////////////////////
    /**
     * @param x X position
     * @param y Y position
     * @param z Z position
     * @param w W position
     */
    public Coordinate4d(final double x1, final double y1, final double z1,
            final double w1) {
        super(x1, y1, z1);
        this.w = w1;
    }

    public Coordinate4d(Coordinate4d coordinate4d) {
        super(coordinate4d.getX(), coordinate4d.getY(), coordinate4d.getZ());
        this.w = coordinate4d.getW();
    }

    /**
     * @param vertex Vertor posio
     * @param w1 W position
     */
    public Coordinate4d(Vertex vertex, double w1) {
        super(vertex);
        this.w = w1; 
    }

    /** @see Vertex#Vertex(double, double, double) */
    public Coordinate4d(double x1, double y1, double z1) {
        super(x1, y1, z1);
        this.w = 1;
    }

    /** @see Vertex#Vertex(Vertex) */
    public Coordinate4d(Vertex vertex) {
        super(vertex);
        this.w = 1;
    }

    /////////////////////////////
    //    BUSINESS METHODS     //
    /////////////////////////////
    public void sum(final double x1, final double y1, final double z1,
            final double w1) {
        super.sum(x1,y1,z1);
        this.w += w1;
    }

    public void sum(final Vertex vertex, final double w1) {
        super.sum(vertex);
        this.w += w1;
    }

    public void sum(final Coordinate4d coordinate4d) {
        this.sum(coordinate4d.getX(), coordinate4d.getY(), coordinate4d.getZ(),
                coordinate4d.getW());
    }

    public float[] asArray() {
        float coordinate[] = new float[] {(float) this.getX(), (float) this.getY(),
                (float) this.getZ(), (float) this.getW()};
        return coordinate;
    }

    /////////////////////////////
    //    ATRIBUTES MODIFIES   //
    /////////////////////////////
    public void setCoordinate4d(final double x1, final double y1,
            final double z1, final double w1) {
        super.setVertex(x1, y1, z1);
        this.w = w1;
    }

    public void setCoordinate4d(final Coordinate4d coordinate4d) {
        super.setVertex(coordinate4d.getX(), coordinate4d.getY(), coordinate4d
                .getZ());
        this.w = coordinate4d.getW();
    }
    /////////////////////////////
    //    GETTERS / SETTERS    //
    /////////////////////////////
    /** @return Returns the w. */
    public double getW() {
        return this.w;
    }
    /** @param w The w to set. */
    public void setW(double w) {
        this.w = w;
    }
}
