/*
 * Light.java
 * Created in 05/04/2006
 */
package feec.ia725.cg.core;


/**
 * @author Lucas Shindi Shimo (lshimo@gmail.com)
 *
 */
public class Light {
    private Coordinate4d position = new Coordinate4d(0, 0, 1, 0);

    private Color specular;
    private Color difuse;
    private Color ambient;

    private double cuttoff = 180.0;

    private double constantAttenuation = 1.0;
    private double linearAttenuation = 0.0;
    private double quadraticAttenuation = 0.0;

    private Vertex direction = new Vertex(0, 0, -1);

    public Light() {
        specular = Color.WHITE;
        difuse = Color.WHITE;
        ambient = Color.WHITE;
    }

    public Light(Coordinate4d position) {
        this();
        this.position = position;
    }

    public Light(Coordinate4d position, Vertex direction) {
        this(position);
        this.direction = direction;
    }

    /////////////////////////////
    //    ATRIBUTES MODIFIES   //
    /////////////////////////////
    /** @param position The position to set. */
    public void setPosition(double x, double y, double z) {
        this.getPosition().setCoordinate4d(x, y, z, 1);
    }
    /** @param direction The direction to set. */
    public void setDirection(double x, double y, double z) {
        this.getDirection().setVertex(x, y, z);
    }
    /////////////////////////////
    //    GETTERS / SETTERS    //
    /////////////////////////////
    /** @return Returns the ambient. */
    public Color getAmbient() {
        return this.ambient;
    }
    /** @param ambient The ambient to set. */
    public void setAmbient(Color ambient) {
        this.ambient = ambient;
    }
    /** @return Returns the difuse. */
    public Color getDifuse() {
        return this.difuse;
    }
    /** @param difuse The difuse to set. */
    public void setDifuse(Color difuse) {
        this.difuse = difuse;
    }
    /** @return Returns the position. */
    public Coordinate4d getPosition() {
        return this.position;
    }
    /** @param position The position to set. */
    public void setPosition(Coordinate4d position) {
        this.position = position;
    }
    /** @return Returns the specular. */
    public Color getSpecular() {
        return this.specular;
    }
    /** @param specular The specular to set. */
    public void setSpecular(Color specular) {
        this.specular = specular;
    }
    /** @return Returns the constantAttenuation. */
    public double getConstantAttenuation() {
        return this.constantAttenuation;
    }
    /** @param constantAttenuation The constantAttenuation to set. */
    public void setConstantAttenuation(double constantAttenuation) {
        this.constantAttenuation = constantAttenuation;
    }
    /** @return Returns the cuttoff. */
    public double getCuttoff() {
        return this.cuttoff;
    }
    /** @param cuttoff The cuttoff to set. */
    public void setCuttoff(double cuttoff) {
        this.cuttoff = cuttoff;
    }
    /** @return Returns the direction. */
    public Vertex getDirection() {
        return this.direction;
    }
    /** @param direction The direction to set. */
    public void setDirection(Vertex direction) {
        this.direction = direction;
    }
    /** @return Returns the linearAttenuation. */
    public double getLinearAttenuation() {
        return this.linearAttenuation;
    }
    /** @param linearAttenuation The linearAttenuation to set. */
    public void setLinearAttenuation(double linearAttenuation) {
        this.linearAttenuation = linearAttenuation;
    }
    /** @return Returns the quadraticAttenuation. */
    public double getQuadraticAttenuation() {
        return this.quadraticAttenuation;
    }
    /** @param quadraticAttenuation The quadraticAttenuation to set. */
    public void setQuadraticAttenuation(double quadraticAttenuation) {
        this.quadraticAttenuation = quadraticAttenuation;
    }
}
