package feec.ia725.cg.engine;

import feec.ia725.cg.core.Angle3d;
import feec.ia725.cg.core.Coordinate4d;
import feec.ia725.cg.core.Vertex;

public class Camera {
    private static final double PI180 = Math.PI / 180.0;
 
	private Vertex position = new Coordinate4d(0, 0, 0, 1);
	 
	private Vertex upVector = new Coordinate4d(0, 1, 0);
	 
	private Angle3d angle = new Angle3d(0, 0);

    /** Define as linhas de viso e a projeo da linha Y */
    private double lx, ly, lz, lyP;

    /**
     * 
     */
    public Camera() {
        this.updateLoV(angle);
    }

    // ///////////////////////////
    //    BUSINESS METHODS     //
    /////////////////////////////
	public void moveForward(double distance) {
        double dx = lx * distance * lyP;
        double dy = ly * distance;
        double dz = lz * distance * lyP;

        this.getPosition().sum(dx, dy, dz);
	}
	 
	public void moveForwardFlat(double distance) {
        double dx = lx * distance;
        double dz = lz * distance;

        this.getPosition().sum(dx, 0, dz);
	}
	 
	public void straffeLeft(double distance) {
	}
	 
	public void straffeLeftFlat(double distance) {
        double dx = - lz * distance;
        double dz = lx * distance;

        this.getPosition().sum(dx, 0, dz);
	}

    /**
     * @param lookingAt The lookingAt to set.
     */
    public Vertex getLookingAt() {
        Vertex looking = new Vertex(this.getPosition());
        looking.sum(lx, ly, lz);
        return looking;
    }

    /////////////////////////////
    //    ATRIBUTES MODIFIES   //
    /////////////////////////////
    /**
     * @param phi The phi to set.
     */
    public void setPhi(double phi) {
        this.angle.setPhi(phi);
        this.updateLoV(angle);
    }
    /**
     * @param theta The theta to set.
     */
    public void setTheta(double theta) {
        this.angle.setTheta(theta);
        this.updateLoV(angle);
    }

    /////////////////////////////
    //    PRIVATE METHODS      //
    /////////////////////////////
    /**
     * Atualiza as linhas de viso.
     */
    private void updateLoV(Angle3d angle3d) {
        double phi = angle3d.getPhi();
        double theta = angle3d.getTheta();

        this.lyP = Math.cos(phi * PI180);
        
        lx = Math.sin(theta * PI180);
        lz = -Math.cos(theta * PI180);
        ly = Math.sin(phi * PI180);
    }

    public void setPosition(double x, double y, double z) {
        this.getPosition().setVertex(x, y, z);
    }

    /////////////////////////////
    //    GETTERS / SETTERS    //
    /////////////////////////////
    /**
     * @return Returns the angle.
     */
    public Angle3d getAngle() {
        return this.angle;
    }
    /**
     * @param angle The angle to set.
     */
    public void setAngle(Angle3d angle) {
        this.angle = angle;
        this.updateLoV(angle);
    }
    /**
     * @return Returns the position.
     */
    public Vertex getPosition() {
        return this.position;
    }
    /**
     * @param position The position to set.
     */
    public void setPosition(Vertex position) {
        this.position = position;
    }
    /**
     * @return Returns the upVector.
     */
    public Vertex getUpVector() {
        return this.upVector;
    }
    /**
     * @param upVector The upVector to set.
     */
    public void setUpVector(Vertex upVector) {
        this.upVector = upVector;
    }

    /** @return Returns the lx. */
    public double getLx() {
        return this.lx;
    }
    /** @return Returns the ly. */
    public double getLy() {
        return this.ly;
    }
    /** @return Returns the lyP. */
    public double getLyP() {
        return this.lyP;
    }
    /** @return Returns the lz. */
    public double getLz() {
        return this.lz;
    }
}