/*
 * MainGameEventListener.java Created in 18/04/2006
 */
package feec.ia725.cg.listener;

import java.awt.event.KeyListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLEventListener;

import feec.ia725.cg.engine.GameEngine;
import feec.ia725.cg.engine.InputEngine;
import feec.ia725.cg.engine.MovementSystem;
import feec.ia725.cg.engine.SceneEngine;

/**
 * @author Lucas Shindi Shimo (lshimo@gmail.com)
 */
public class MainGameEventListener implements GLEventListener {
    private GameEngine gameEngine;
    private InputEngine inputEngine;
    private SceneEngine sceneEngine;
    private MovementSystem movementEngine;

    /**
     * Default Constructor
     */
    public MainGameEventListener() {
        this.gameEngine = new GameEngine();
        this.inputEngine = new InputEngine(gameEngine);
        this.sceneEngine = new SceneEngine(gameEngine);
        this.movementEngine = new MovementSystem(gameEngine);
        
    }

    //////////////////////
    //      EVENTS      //
    //////////////////////
    /**
     * @see javax.media.opengl.GLEventListener#init(javax.media.opengl.GLAutoDrawable)
     */
    public void init(GLAutoDrawable drawable) {
        gameEngine.init();
        drawable.swapBuffers();
    }

    /**
     *  @see javax.media.opengl.GLEventListener#display(javax.media.opengl.GLAutoDrawable)
     */
    public void display(GLAutoDrawable drawable) {
        gameEngine.run(drawable);
    }

    /**
     * @see javax.media.opengl.GLEventListener#reshape(javax.media.opengl.GLAutoDrawable,
     *      int, int, int, int)
     */
    public void reshape(GLAutoDrawable drawable, int x, int y, int width,
            int height) {
    }

    /**
     * @see javax.media.opengl.GLEventListener#displayChanged(javax.media.opengl.GLAutoDrawable,
     *      boolean, boolean)
     */
    public void displayChanged(GLAutoDrawable drawable, boolean modeChanged,
            boolean deviceChanged) {
    }

    /////////////////////////////
    //    GETTERS / SETTERS    //
    /////////////////////////////
    /** @return Returns the KeyListener. */
    public KeyListener getKeyListener() {
        return this.inputEngine;
    }

    /** @return Returns the MouseMotionListener. */
    public MouseMotionListener getMouseMotionListener() {
        return this.inputEngine;
    }

    /** @return Returns the MouseListener. */
    public MouseListener getMouseListener() {
        return this.inputEngine;
    }

    /** @return Returns the gameEngine. */
    public GameEngine getGameEngine() {
        return this.gameEngine;
    }

    /** @param gameEngine The gameEngine to set. */
    public void setGameEngine(GameEngine gameEngine) {
        this.gameEngine = gameEngine;
    }

    /** @return Returns the inputEngine. */
    public InputEngine getInputEngine() {
        return this.inputEngine;
    }

    /** @param inputEngine The inputEngine to set. */
    public void setInputEngine(InputEngine inputEngine) {
        this.inputEngine = inputEngine;
    }

    /** @return Returns the sceneEngine. */
    public SceneEngine getSceneEngine() {
        return this.sceneEngine;
    }

    /** @param sceneEngine The sceneEngine to set. */
    public void setSceneEngine(SceneEngine sceneEngine) {
        this.sceneEngine = sceneEngine;
    }

    /** @return Returns the movementEngine. */
    public MovementSystem getMovementEngine() {
        return this.movementEngine;
    }
    
    /** @param movementEngine The movementEngine to set. */
    public void setMovementEngine(MovementSystem movementEngine) {
        this.movementEngine = movementEngine;
    }
}
