/*
 * MainGameFrame.java
 * Created in 18/04/2006
 */
package feec.ia725.cg.listener;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JFrame;

/**
 * @author Lucas Shindi Shimo (lshimo@gmail.com)
 *
 */
public class MainGameFrame extends JFrame {
    /** Default Serial Version UID */
    private static final long serialVersionUID = 1L;
    
    /**
     * 
     */
    public MainGameFrame(String title) {
        super(title);
        
        //kill the process when the JFrame is closed
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setSize(640, 480);

        centerWindow(this);
    }

    public void centerWindow(Component frame) {
        Dimension screenSize = 
           Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize  = frame.getSize();

        if (frameSize.width  > screenSize.width ) 
           frameSize.width  = screenSize.width;
        if (frameSize.height > screenSize.height) 
           frameSize.height = screenSize.height;

        frame.setLocation (
            (screenSize.width  - frameSize.width ) >> 1, 
            (screenSize.height - frameSize.height) >> 1
        );
    }   
}
