/*
 * MainGame.java
 * Created in 18/04/2006
 */
package feec.ia725.cg.main;

import java.awt.BorderLayout;

import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLCapabilities;
import javax.swing.SwingUtilities;

import com.sun.opengl.util.Animator;
import com.sun.opengl.util.FPSAnimator;

import feec.ia725.cg.listener.MainGameEventListener;
import feec.ia725.cg.listener.MainGameFrame;

/**
 * @author Lucas Shindi Shimo (lshimo@gmail.com)
 *
 */
public class MainGame {
    /** Default Serial Version UID */
    private static final long serialVersionUID = 1L;

    private static Animator animator = null;

    /**
     * @param args
     */
    public static void main(String[] args) {
        final MainGameFrame gameFrame = new MainGameFrame("Main Game");

        //Now we will create our GLCanvas 
        GLCapabilities glcaps = new GLCapabilities();
        glcaps.setDoubleBuffered(true);

        // listener principal
        MainGameEventListener eventListener = new MainGameEventListener();

        GLCanvas glcanvas = new GLCanvas(glcaps);
        glcanvas.addGLEventListener(eventListener);
        glcanvas.addKeyListener(eventListener.getKeyListener());
        glcanvas.addMouseMotionListener(eventListener.getMouseMotionListener());
        glcanvas.addMouseListener(eventListener.getMouseListener());
        glcanvas.setFocusable(true);
        glcanvas.requestFocus();
        
        //create the animator
//        animator = new Animator(glcanvas);
        animator = new FPSAnimator(glcanvas, 70);

        //add the GLCanvas just like we would any Component
        gameFrame.getContentPane().add(glcanvas, BorderLayout.CENTER);

        // show what we've done
        SwingUtilities.invokeLater (
            new Runnable() {
                public void run() {
                    gameFrame.setVisible(true);
                }
            }
        );
        
        //start the animator
        SwingUtilities.invokeLater (
            new Runnable() {
                public void run() {
                    animator.start();
                }
            }
        );
    }
}
